Bug 790468 - Review Request: gperftools - Very fast malloc and performance analysis tools
Summary: Review Request: gperftools - Very fast malloc and performance analysis tools
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jared Smith
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-02-14 15:44 UTC by Tom "spot" Callaway
Modified: 2012-03-06 07:04 UTC (History)
3 users (show)

Fixed In Version: gperftools-2.0-3.el6.2
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-02-21 02:23:02 UTC
jsmith.fedora: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Tom "spot" Callaway 2012-02-14 15:44:48 UTC
Spec URL: http://spot.fedorapeople.org/gperftools.spec
SRPM URL: http://spot.fedorapeople.org/gperftools-2.0-1.fc17.src.rpm
Koji Rawhide Scratch Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=3790047
Description: 
Perf Tools is a collection of performance analysis tools, including a
high-performance multi-threaded malloc() implementation that works
particularly well with threads and STL, a thread-friendly heap-checker,
a heap profiler, and a cpu-profiler.

*** NOTE *** 
This is a rename review request, this package recently renamed to "gperftools" from "google-perftools". Provides/Obsoletes have been added for all subpackages.

Comment 1 Jared Smith 2012-02-14 17:37:30 UTC
[jsmith@hat-trick review]$ rpmlint gperftools.spec
gperftools.spec: W: invalid-url Source0: http://gperftools.googlecode.com/files/gperftools-2.0.tar.gz HTTP Error 404: Not Found
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

[jsmith@hat-trick review]$ rpmlint gperftools-2.0-1.fc17.src.rpm 
gperftools.src: W: spelling-error Summary(en_US) malloc -> mallow
gperftools.src: W: spelling-error %description -l en_US Perf -> Serf, Perl, Peru
gperftools.src: W: spelling-error %description -l en_US multi -> mulch, mufti
gperftools.src: W: spelling-error %description -l en_US malloc -> mallow
gperftools.src: W: spelling-error %description -l en_US profiler -> profile, profiles, profiled
gperftools.src: W: spelling-error %description -l en_US cpu -> CPU, cup, cu
gperftools.src: W: invalid-url Source0: http://gperftools.googlecode.com/files/gperftools-2.0.tar.gz HTTP Error 404: Not Found
1 packages and 0 specfiles checked; 0 errors, 7 warnings.

[jsmith@hat-trick x86_64]$ rpmlint gperftools-2.0-1.fc16.x86_64.rpm 
gperftools.x86_64: W: spelling-error Summary(en_US) malloc -> mallow
gperftools.x86_64: W: spelling-error %description -l en_US Perf -> Serf, Perl, Peru
gperftools.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
gperftools.x86_64: W: spelling-error %description -l en_US malloc -> mallow
gperftools.x86_64: W: spelling-error %description -l en_US profiler -> profile, profiles, profiled
gperftools.x86_64: W: spelling-error %description -l en_US cpu -> CPU, cup, cu
gperftools.x86_64: E: no-binary
1 packages and 0 specfiles checked; 1 errors, 6 warnings.

[jsmith@hat-trick x86_64]$ rpmlint gperftools-devel-2.0-1.fc16.x86_64.rpm 
gperftools-devel.x86_64: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

[jsmith@hat-trick x86_64]$ rpmlint gperftools-libs-2.0-1.fc16.x86_64.rpm 
gperftools-libs.x86_64: W: spelling-error %description -l en_US libtcmalloc -> allocation
gperftools-libs.x86_64: W: spelling-error %description -l en_US libprofiler -> profiterole
gperftools-libs.x86_64: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

[ O K  ] MUST: rpmlint must be run on every package. The output should be posted
in the review.

$ rpmlint <spec> <srpm> <rpm>

[ O K ] MUST: The package must be named according to the Package Naming
Guidelines.

[ O K ] MUST: The spec file name must match the base package %{name}, in the
format %{name}.spec unless your package has an exemption.

[ O K ] MUST: The package must meet the Packaging Guidelines.

[ O K ] MUST: The package must be licensed with a Fedora approved license and
meet the Licensing Guidelines.

[ O K ] MUST: The License field in the package spec file must match the actual
license. 

[ N/A ] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.

[ O K ] MUST: The spec file must be written in American English. 

[ O K ] MUST: The spec file for the package MUST be legible. 

[ O K ] MUST: The sources used to build the package must match the upstream
source, as provided in the spec URL. Reviewers should use md5sum for this task.
If no upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.

[jsmith@hat-trick review]$ md5sum gperftools-2.0.tar.gz; curl -s -o - http://gperftools.googlecode.com/files/gperftools-2.0.tar.gz | md5sum -
13f6e8961bc6a26749783137995786b6  gperftools-2.0.tar.gz
13f6e8961bc6a26749783137995786b6  -


[ O K ] MUST: The package MUST successfully compile and build into binary rpms
on at least one primary architecture. 

[ O K ] MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line. 

[ O K ] MUST: All build dependencies must be listed in BuildRequires, except
for any that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.

[ O K ] MUST: The spec file MUST handle locales properly. This is done by using
the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[ O K ] MUST: Every binary RPM package (or subpackage) which stores shared
library files (not just symlinks) in any of the dynamic linker's default paths,
must call ldconfig in %post and %postun. 

[ O K ] MUST: Packages must NOT bundle copies of system libraries.

[ O K ] MUST: If the package is designed to be relocatable, the packager must
state this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker. 

[ O K ] MUST: A package must own all directories that it creates. If it does
not create a directory that it uses, then it should require a package which
does create that directory. 

[ O K ] MUST: A Fedora package must not list a file more than once in the spec
file's %files listings. (Notable exception: license texts in specific
situations)

[ ??? ] MUST: Permissions on files must be set properly. Executables should be
set with executable permissions, for example. Every %files section must include
a %defattr(...) line. 

# no %defattr(...) line, and no other permissions set

[ O K ] MUST: Each package must consistently use macros. 

[ O K ] MUST: The package must contain code, or permissible content. 

[ N/A ] MUST: Large documentation files must go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity). 

[ N/A ] MUST: If a package includes something as %doc, it must not affect the
runtime of the application. To summarize: If it is in %doc, the program must
run properly if it is not present. 

[ O K ] MUST: Header files must be in a -devel package. 

[ N/A ] MUST: Static libraries must be in a -static package. 

[ O K ] MUST: If a package contains library files with a suffix (e.g.
libfoo.so.1.1), then library files that end in .so (without suffix) must go in
a -devel package. 

[ O K ] MUST: In the vast majority of cases, devel packages must require the
base package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release} 

[ O K ] MUST: Packages must NOT contain any .la libtool archives, these must be
removed in the spec if they are built.

[ N/A ] MUST: Packages containing GUI applications must include a
%{name}.desktop file, and that file must be properly installed with
desktop-file-install in the %install section. If you feel that your packaged
GUI application does not need a .desktop file, you must put a comment in the
spec file with your explanation. 

[ O K ] MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another
package owns, then please present that at package review time. 

[ O K ] MUST: All filenames in rpm packages must be valid UTF-8.

[ N/A ] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.

[ O K ] SHOULD: The reviewer should test that the package builds in mock. 
[ ??? ] SHOULD: The package should compile and build into binary rpms on all supported architectures. 
# apparently doesn't work on ppc64, but a bugzilla ticket has been filed
# has it been tested on ARM (just out of curiosity)?
[ O K ] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[ N/A ] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. 
[ O K ] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. 
[ N/A ] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. 
[ N/A ] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. 
[ O K ] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

The only things I am concerned about are the no-binary error from rpmlint, and whether or not you should add a %defattr(...) line for file permissions.

Comment 2 Tom "spot" Callaway 2012-02-14 17:48:15 UTC
%defattr() is no longer necessary in current versions of Fedora.

As to the no-binary error, I reworked the package so that there is now a "pprof" subpackage which is noarch, and the rest of the packages are arch specific. This sidesteps the issue of having to make the "main" package noarch with an ExclusiveArch rule.

New SRPM: http://spot.fedorapeople.org/gperftools-2.0-2.fc17.src.rpm
New SPEC: http://spot.fedorapeople.org/gperftools.spec

Comment 3 Jared Smith 2012-02-14 18:52:36 UTC
OK, that updated spec file clears up my remaining concerns.  

PACKAGE IS APPROVED

Comment 4 Tom "spot" Callaway 2012-02-14 19:01:37 UTC
New Package SCM Request
=======================
Package Name: gperftools
Short Description: Very fast malloc and performance analysis tools
Owners: spot
Branches: el6 f15 f16 f17
InitialCC:

Comment 5 Gwyn Ciesla 2012-02-14 19:14:29 UTC
Git done (by process-git-requests).

Comment 6 Fedora Update System 2012-02-14 20:49:50 UTC
gperftools-2.0-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/gperftools-2.0-3.fc16

Comment 7 Fedora Update System 2012-02-14 20:49:59 UTC
gperftools-2.0-3.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/gperftools-2.0-3.fc15

Comment 8 Fedora Update System 2012-02-14 20:50:07 UTC
gperftools-2.0-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/gperftools-2.0-3.fc17

Comment 9 Fedora Update System 2012-02-14 20:50:17 UTC
gperftools-2.0-3.el6.1 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/gperftools-2.0-3.el6.1

Comment 10 Fedora Update System 2012-02-15 01:19:54 UTC
gperftools-2.0-3.el6.1 has been pushed to the Fedora EPEL 6 testing repository.

Comment 11 Fedora Update System 2012-02-21 02:23:02 UTC
ceph-0.41-1.fc17, gperftools-2.0-4.fc17 has been pushed to the Fedora 17 stable repository.

Comment 12 Fedora Update System 2012-02-28 09:57:36 UTC
gperftools-2.0-4.fc15 has been pushed to the Fedora 15 stable repository.

Comment 13 Fedora Update System 2012-02-28 10:06:45 UTC
ceph-0.39-2.fc16, gperftools-2.0-4.fc16 has been pushed to the Fedora 16 stable repository.

Comment 14 Fedora Update System 2012-03-06 07:04:38 UTC
gperftools-2.0-3.el6.2 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.